<template>
    <NuxtLayout :name="'dashboard'">
        <div class="p-8 w-screen bg-contain bg-center" style="background-image: url('/assets/img/auth/banner.jpg');">
            <CustomTable :tableName="tableName" :currentPage="currentPage" :limitPerPage="itemPerPage" :heads="heads"
                @on-search="search" :items="users" />
        </div>
    </NuxtLayout>
</template>

<script lang="ts">
definePageMeta({
    middleware: ["auth"]
})
export default {
    layout: "dashboard",
    data() {
        return {
            toastVisible: false,
            toastTitle: "",
            toastMessage: "",
            tableName: "Users",
            isLoading: false,
            currentPage: 1,
            itemPerPage: 10,
            heads: [
                "No",
                "Name",
                "Username",
                "Email",
                "Role",
                "Action",
            ],
            users: [],
        }
    },
    mounted() {
        this.fetchData();
    },
    methods: {
        fetchData(query: string = '') {
            this.isLoading = true;
            const toastStore = useToastStore();
            const config = useRuntimeConfig();
            this.$api
                .get(`/user?search=${query}&page=${this.currentPage}&limit=${this.itemPerPage}`, {
                    headers: {
                        Authorization: `Bearer ${localStorage.getItem("access_token")}`,
                    },
                })
                .then((response) => {
                    let datas = response.data;
                    datas.map((item: any) => {
                        item.id = item.id;
                        item.name = item.name;
                        item.username = item.username;
                        item.email = item.email;
                        item.role = item.role.name;
                        item.action = [
                            // {
                            //     icon: "material-symbols:edit-outline",
                            //     color: "bg-blue-500",
                            //     route: `/user/${item.id}`,
                            //     disabled: false
                            // },
                            {
                                icon: "material-symbols:delete-outline-rounded",
                                color: "bg-red-500",
                                disabled: false,
                                callback: 'delete-file',
                            },
                        ];
                        delete item.documents;
                        delete item.role.name;
                    });
                    this.users = datas;
                })
        }, search(query: string) {
            this.fetchData(query);
        },
        pageUpdate(page: number) {
            this.currentPage = page;
            this.fetchData();
        },
        deleteUser(id: number) {
            // Add your logic for deleting a file
            console.log('delete')
            console.log(id)
            this.isLoading = true;
            const toastStore = useToastStore();
            this.$api.delete(`/file/${id}`, {
                headers: {
                    Authorization: `Bearer ${localStorage.getItem("access_token")}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let title = response.data.title;
                    this.isLoading = false;
                    this.fetchData();
                    toastStore.showToast(`Dokumen ${title} telah dihapus`, 'success');
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.isLoading = false;
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                })
        }
    },
}

</script>